public class Player {
    private Piece[] pieces = new Piece[16] ;
    private PieceColor pieceColor;

    public Piece[] getPieces() {
        return pieces ;
    }

    public PieceColor getPieceColor() {
        return pieceColor;
    }

    public void setPieces(Piece[] pieces) {
        this.pieces = pieces ;
    }

    public void setPieceColor(PieceColor pieceColor) {
        this.pieceColor = pieceColor;
    }

    public  Player(PieceColor pieceColor) {
        this.pieceColor = pieceColor;
        if (pieceColor == PieceColor.WHITE) {
            for(int i=0 ; i<8 ; i++) {
                pieces[i] = new Pawn(new Cell(1,i), pieceColor) ;
            }
            pieces[8] = new Bishop(new Cell(0,2), pieceColor) ;
            pieces[9] = new Bishop(new Cell(0,5), pieceColor) ;
            pieces[10] = new Knight(new Cell(0,1), pieceColor) ;
            pieces[11] = new Knight(new Cell(0,6), pieceColor) ;
            pieces[12] = new Rook(new Cell(0,0), pieceColor) ;
            pieces[13] = new Rook(new Cell(0,7), pieceColor) ;
            pieces[14] = new King(new Cell(0,4), pieceColor) ;
            pieces[15] = new Queen(new Cell(0,3), pieceColor) ;

        }
        else {
            for(int i=0 ; i<8 ; i++){
                pieces[i] = new Pawn(new Cell(6,i), pieceColor) ;
            }
            pieces[8] = new Bishop(new Cell(7,2), pieceColor) ;
            pieces[9] = new Bishop(new Cell(7,5), pieceColor) ;
            pieces[10] = new Knight(new Cell(7,1), pieceColor) ;
            pieces[11] = new Knight(new Cell(7,6), pieceColor) ;
            pieces[12] = new Rook(new Cell(7,0), pieceColor) ;
            pieces[13] = new Rook(new Cell(7,7), pieceColor) ;
            pieces[14] = new King(new Cell(7,4), pieceColor) ;
            pieces[15] = new Queen(new Cell(7,3), pieceColor) ;
        }
    }
}